## bismuth 2.3.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth)

option(
  USE_TSC
  "Use TypeScript Compler to check the code before bundling \
  using esbuild. This could be useful, if you know, that the \
  code is correct and you want to speed up building times. \
  For example - you are a packager."
  ON
)

option(
  USE_NPM
  "Use npm installed packages during the build. You might \
  want to disable this option, if you want to use natively \
  installed tools. In particular build systems won't use \
  \"npx\" prefix before commands."
  ON
)

set(QT_MIN_VERSION "5.15.0")
set(KF5_MIN_VERSION "5.80.0")

# HACK: Use git to get the recent version
# We could explicitly set the version via project declaration
# But this would conflict with package.json and would
# Require automatic change via Release Please time CI
execute_process(COMMAND "git" "describe" "--tags" "--abbrev=0" OUTPUT_VARIABLE CMAKE_PROJECT_VERSION)
string(REPLACE "\n" "" CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION}")
string(REPLACE "v" "" CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION}")

# TODO: Less hacky solution, however it requires CMake 3.19
# which is not so common across distros as of now.
# Uncomment when cmake_minimum_required >= 3.19.
#
# # Set the project version
# file(READ ${CMAKE_CURRENT_SOURCE_DIR}/package.json PACKAGE_JSON)
# string(JSON CMAKE_PROJECT_VERSION GET ${PACKAGE_JSON} version)
# unset(PACKAGE_JSON)

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)

find_package(
  Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
  DBus
  Quick
  Svg
)

find_package(
  KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
  I18n
  KCMUtils
  Declarative
  Config
)

add_subdirectory(src)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

add_subdirectory(kcm)
add_subdirectory(kwinscript)

=== src/kcm/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth-kcm)

add_library(kcm_bismuth MODULE)

qt_add_dbus_interface(kwin_dbus_srcs org.kde.KWin.xml kwin_interface)

target_sources(
  kcm_bismuth
  PRIVATE
  bismuth.cpp
  ${kwin_dbus_srcs}
)

target_link_libraries(
  kcm_bismuth
  PRIVATE
  Qt5::Core
  Qt5::DBus
  KF5::CoreAddons
  KF5::I18n
  KF5::QuickAddons
  KF5::ConfigCore
  KF5::ConfigGui
)

kconfig_add_kcfg_files(kcm_bismuth GENERATE_MOC bismuth_config.kcfgc)
kcoreaddons_desktop_to_json(kcm_bismuth "package/metadata.desktop")

install(FILES "bismuth_config.kcfg" DESTINATION ${KDE_INSTALL_KCFGDIR})
install(TARGETS kcm_bismuth DESTINATION ${KDE_INSTALL_PLUGINDIR}/kcms)
install(FILES package/metadata.desktop RENAME kcm_bismuth.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})

kpackage_install_package(package kcm_bismuth kcms)

add_subdirectory(icons)
add_subdirectory(kconf_update)

=== src/kwinscript/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth-kwinscript)

add_custom_target(
  KWinScript ALL
  COMMENT "🏗️ Building KWin Script..."
  DEPENDS
  "bismuth/contents/code/index.mjs"
  "bismuth/contents/ui"
)

file(GLOB_RECURSE TYPESCRIPT_SOURCES CONFIGURE_DEPENDS "*.ts")

if(USE_TSC)
  set(TSC_COMMAND "tsc" "--noEmit" "--incremental")
  if(USE_NPM)
    list(PREPEND TSC_COMMAND "npx")
  else()
    message(
      FATAL_ERROR
      "You are trying to use USE_TSC=ON with USE_NPM=OFF options. "
      "This is currently unsupported, because in this case TypeScript Compiler "
      "is going to throw a bunch of errors at you, because it cannot "
      "find a lot of stuff, like Jest or \"console\" JS global variable. "
      "\n"
      "This is happening, because normally TSC thinks, that he looks at "
      "code, that will be used with NPM packages and Node.js runtime. "
      "This is of course is not OK, but we ought to live with this "
      "behavior, because we need to use Jest Unit Testing Framework. "
      "\n"
      "You are supposed to use USE_NPM=OFF only with USE_TSC=OFF, "
      "because, if you are using these options at all, it means, that "
      "you are most probably a packager and packagers do not need "
      "to check TypeScript code for correctness."
    )
  endif()
endif()

set(
  ESBUILD_COMMAND
  "esbuild"
  "--bundle" "${CMAKE_CURRENT_SOURCE_DIR}/index.ts"
  "--outfile=${CMAKE_CURRENT_BINARY_DIR}/bismuth/contents/code/index.mjs"
  "--format=esm"
  "--platform=neutral"
)
if(USE_NPM)
  list(PREPEND ESBUILD_COMMAND "npx")
endif()

add_custom_command(
  OUTPUT "bismuth/contents/code/index.mjs"
  COMMAND ${TSC_COMMAND}
  COMMAND ${ESBUILD_COMMAND}
  COMMAND DEPENDS ${TYPESCRIPT_SOURCES}
  COMMENT "🏗️ Compiling and bundling TypeScript sources..."
)

add_custom_command(
  OUTPUT "bismuth/contents/ui"
  COMMAND "${CMAKE_COMMAND}" "-E" "copy_directory"
  "${CMAKE_CURRENT_SOURCE_DIR}/ui" "${CMAKE_CURRENT_BINARY_DIR}/bismuth/contents/ui"
  DEPENDS
  "${CMAKE_CURRENT_SOURCE_DIR}/ui/main.qml"
  "${CMAKE_CURRENT_SOURCE_DIR}/ui/TrayItem.qml"
  "${CMAKE_CURRENT_SOURCE_DIR}/ui/popup.qml"
  COMMENT "📑 Preparing UI and metadata files..."
)

configure_file("metadata.desktop" "bismuth/metadata.desktop" @ONLY)

install(
  DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bismuth"
  DESTINATION "${KDE_INSTALL_DATAROOTDIR}/kwin/scripts"
)

add_subdirectory(icons)

=== src/kcm/icons/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

ecm_install_icons(
  ICONS
  sc-apps-bismuth.svg
  22-categories-bismuth-kcm.svg
  64-categories-bismuth-kcm.svg
  DESTINATION ${KDE_INSTALL_ICONDIR}
)

=== src/kcm/kconf_update/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

install(
  FILES old_conf_ui.upd
  DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR}
)
install(
  PROGRAMS old_conf_ui.sh
  DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR}
)

=== src/kwinscript/icons/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Ignacy Kajdan <git@verahawk.com>
# SPDX-License-Identifier: MIT

ecm_install_icons(
  ICONS
  32-status-bismuth-column.svg
  32-status-bismuth-floating.svg
  32-status-bismuth-monocle.svg
  32-status-bismuth-quarter.svg
  32-status-bismuth-spiral.svg
  32-status-bismuth-spread.svg
  32-status-bismuth-stair.svg
  32-status-bismuth-tile.svg
  DESTINATION ${KDE_INSTALL_ICONDIR}
)

=== src/kwinscript/kconf_update/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@genda.life>
# SPDX-License-Identifier: MIT

install(
  FILES local_install_to_global.upd
  DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR}
)
install(
  PROGRAMS local_install_to_global.sh
  DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR}
)

=== debian/changelog ===
bismuth (2.3.0-0ubuntu1) jammy; urgency=medium

  * Initial release for Ubuntu (LP: #1960272)
  * Update maintainer
  * Add self to copyright

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 07 Feb 2022 12:44:43 -0800

Old changelog:

bismuth (2.2.0-1) unstable; urgency=medium

  * First debian package

 -- Blake Lee <blake@volian.org>  Sat, 18 Dec 2021 16:46:58 -0500

=== debian/control ===
Source: bismuth
Section: kde
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
XSBC-Original-Maintainer: Volian Developers <volian-devel@volian.org>
Uploaders: Blake Lee <blake@volian.org>
Homepage: https://github.com/Bismuth-Forge/bismuth
VCS-Git: https://gitlab.com/volian/bismuth.git
VCS-Browser: https://gitlab.com/volian/bismuth
Standards-Version: 4.6.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
	cmake,
	ninja-build,
	extra-cmake-modules,
	kirigami2-dev,
	libkf5config-dev,
	libkf5configwidgets-dev,
	libkf5coreaddons-dev,
	libkf5declarative-dev,
	libkf5i18n-dev,
	libkf5kcmutils-dev,
	libqt5svg5-dev,
	esbuild,
	qml-module-qtquick-controls2,
	qml-module-qtquick-controls,
	qml-module-qtquick-dialogs,
	qml-module-qtquick-extras,
	qml-module-qtquick-layouts,
	qml-module-qtquick-localstorage,
	qml-module-qtquick-particles2,
	qml-module-qtquick-pdf,
	qml-module-qtquick-privatewidgets,
	qml-module-qtquick-scene2d,
	qml-module-qtquick-scene3d,
	qml-module-qtquick-shapes,
	qml-module-qtquick-templates2,
	qml-module-qtquick-virtualkeyboard,
	qml-module-qtquick-window2,
	qml-module-qtquick-xmllistmodel,
	qml-module-qtquick2,
	qtbase5-dev,
	qtdeclarative5-dev,
	qtquickcontrols2-5-dev,

Package: kwin-bismuth
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
	${misc:Depends},
	hicolor-icon-theme,
	systemsettings (>= 4:5.20~),
	kwin-x11 (>= 4:5.20~) | kwin,
Description: KDE Plasma extension for tiling windows
 KDE Plasma extension, that lets you tile your windows
 automatically and manage them via keyboard, just like
 in classical tiling window managers (i3, dwm or XMonad).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all, nocheck
DEBDIR = debian
DESTDIR = $(DEBDIR)/kwin-bismuth/usr

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_TSC=OFF -DUSE_NPM=OFF

## bismuth 3.1.4

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth)

option(
  USE_TSC
  "Use TypeScript Compler to check the code before bundling \
  using esbuild. This could be useful, if you know, that the \
  code is correct and you want to speed up building times. \
  For example - you are a packager."
  ON)

option(
  USE_NPM
  "Use npm installed packages during the build. You might \
  want to disable this option, if you want to use natively \
  installed tools. In particular build systems won't use \
  \"npx\" prefix before commands."
  ON)

set(QT_MIN_VERSION "5.15.0")
set(KF5_MIN_VERSION "5.78.0")

# HACK: Use git to get the recent version We could explicitly set the version
# via project declaration But this would conflict with package.json and would
# Require automatic change via Release Please time CI
execute_process(COMMAND "git" "describe" "--tags" "--abbrev=0"
                OUTPUT_VARIABLE CMAKE_PROJECT_VERSION)
string(REPLACE "\n" "" CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION}")
string(REPLACE "v" "" CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION}")

# TODO: Less hacky solution, however it requires CMake 3.19 which is not so
# common across distros as of now. Uncomment when cmake_minimum_required >=
# 3.19.
#
# # Set the project version file(READ ${CMAKE_CURRENT_SOURCE_DIR}/package.json
# PACKAGE_JSON) string(JSON CMAKE_PROJECT_VERSION GET ${PACKAGE_JSON} version)
# unset(PACKAGE_JSON)

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/")

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEClangFormat)
include(ECMInstallIcons)
include(ECMQtDeclareLoggingCategory)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS DBus Quick Svg
                                                              Test)

find_package(
  KF5 ${KF5_MIN_VERSION} REQUIRED
  COMPONENTS Config
             ConfigWidgets
             CoreAddons
             Declarative
             GlobalAccel
             KCMUtils
             I18n)

find_package(KDecoration2 REQUIRED)

include_directories("${PROJECT_SOURCE_DIR}/external")

if(NOT BUILD_TESTING)
  add_compile_definitions(DOCTEST_CONFIG_DISABLE)
endif()

add_subdirectory(src)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== Makefile ===
# SPDX-FileCopyrightText: Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

MAKEFLAGS += --always-make

all: build

clean:
	scripts/clean.sh

build:
	scripts/build.sh

sysdep-install:
	scripts/sysdep-install.sh

install: build
	scripts/install.sh

uninstall:
	scripts/uninstall.sh

restart-kwin-x11:
	kwin_x11 --replace & disown

restart-plasma:
	plasmashell --replace & disown

docs:
	npx typedoc --out build/docs

test:
	scripts/test.sh

setup-dev-env: sysdep-install
	pre-commit install
	npm install # Install development dependencies

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021-2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

add_subdirectory(config)
add_subdirectory(core)
add_subdirectory(kcm)
add_subdirectory(kdecoration)
add_subdirectory(kwinscript)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

include(doctest)

add_subdirectory(core)

=== src/config/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

project(bismuth-config)

install(FILES "bismuth_config.kcfg" DESTINATION ${KDE_INSTALL_KCFGDIR})

add_subdirectory(kconf_update)

=== src/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

project(bismuth-core)

add_library(bismuth_core SHARED)
add_library(Bismuth::Core ALIAS bismuth_core)

ecm_qt_declare_logging_category(
  BISMUTH_LOG
  HEADER
  logger.hpp
  IDENTIFIER
  Bi
  CATEGORY_NAME
  org.kde.bismuth
  DEFAULT_SEVERITY
  Debug
  EXPORT
  Bismuth
  DESCRIPTION
  "Bismuth Plasma Tiling Extension")

add_subdirectory(kconf_update)

target_sources(bismuth_core PRIVATE qml-plugin.cpp ts-proxy.cpp controller.cpp
                                    qmldir ${BISMUTH_LOG})

target_link_libraries(
  bismuth_core
  PRIVATE Qt5::Core
          Qt5::Quick
          Qt5::Qml
          KF5::ConfigCore
          KF5::ConfigGui
          KF5::GlobalAccel
          KF5::I18n)

kconfig_add_kcfg_files(bismuth_core GENERATE_MOC "config.kcfgc")

ecm_qt_install_logging_categories(
  EXPORT Bismuth FILE bismuth.categories DESTINATION
  ${KDE_INSTALL_LOGGINGCATEGORIESDIR})

install(FILES "qmldir" DESTINATION "${KDE_INSTALL_QMLDIR}/org/kde/bismuth/core")

install(TARGETS bismuth_core
        DESTINATION "${KDE_INSTALL_QMLDIR}/org/kde/bismuth/core")

=== src/kcm/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth-kcm)

add_library(kcm_bismuth MODULE)

qt_add_dbus_interface(kwin_dbus_srcs org.kde.KWin.xml kwin_interface)

target_sources(kcm_bismuth PRIVATE bismuth.cpp ${kwin_dbus_srcs})

target_link_libraries(
  kcm_bismuth
  PRIVATE Qt5::Core
          Qt5::DBus
          KF5::CoreAddons
          KF5::I18n
          KF5::QuickAddons
          KF5::ConfigCore
          KF5::ConfigGui)

kconfig_add_kcfg_files(kcm_bismuth GENERATE_MOC "bismuth_config.kcfgc")
kcoreaddons_desktop_to_json(kcm_bismuth "package/metadata.desktop")

install(TARGETS kcm_bismuth DESTINATION ${KDE_INSTALL_PLUGINDIR}/kcms)
install(
  FILES package/metadata.desktop
  RENAME kcm_bismuth.desktop
  DESTINATION ${KDE_INSTALL_KSERVICES5DIR})

kpackage_install_package(package kcm_bismuth kcms)

add_subdirectory(icons)

=== src/kdecoration/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth-kdecoration)

add_library(bismuth_kdecoration MODULE)

target_sources(bismuth_kdecoration PRIVATE decoration.cpp decoration.hpp)

target_link_libraries(
  bismuth_kdecoration
  PUBLIC Qt::Core
  PRIVATE KDecoration2::KDecoration KF5::ConfigCore KF5::ConfigWidgets)

install(TARGETS bismuth_kdecoration
        DESTINATION ${KDE_INSTALL_PLUGINDIR}/org.kde.kdecoration2)

=== src/kwinscript/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(bismuth-kwinscript)

add_custom_target(
  KWinScript ALL
  COMMENT "🏗️ Building KWin Script..."
  DEPENDS "bismuth/contents/code/index.mjs" "bismuth/contents/ui")

file(GLOB_RECURSE TYPESCRIPT_SOURCES CONFIGURE_DEPENDS "*.ts")

if(USE_TSC)
  set(TSC_COMMAND "tsc" "--noEmit" "--incremental")
  if(USE_NPM)
    list(PREPEND TSC_COMMAND "npx")
  else()
    message(
      FATAL_ERROR
        "You are trying to use USE_TSC=ON with USE_NPM=OFF options. "
        "This is currently unsupported, because in this case TypeScript Compiler "
        "is going to throw a bunch of errors at you, because it cannot "
        "find a lot of stuff, like Jest or \"console\" JS global variable. "
        "\n"
        "This is happening, because normally TSC thinks, that he looks at "
        "code, that will be used with NPM packages and Node.js runtime. "
        "This is of course is not OK, but we ought to live with this "
        "behavior, because we need to use Jest Unit Testing Framework. "
        "\n"
        "You are supposed to use USE_NPM=OFF only with USE_TSC=OFF, "
        "because, if you are using these options at all, it means, that "
        "you are most probably a packager and packagers do not need "
        "to check TypeScript code for correctness.")
  endif()
endif()

set(ESBUILD_COMMAND
    "esbuild" "--bundle" "${CMAKE_CURRENT_SOURCE_DIR}/index.ts"
    "--outfile=${CMAKE_CURRENT_BINARY_DIR}/bismuth/contents/code/index.mjs"
    "--format=esm" "--platform=neutral")
if(USE_NPM)
  list(PREPEND ESBUILD_COMMAND "npx")
endif()

add_custom_command(
  OUTPUT "bismuth/contents/code/index.mjs"
  COMMAND ${TSC_COMMAND}
  COMMAND ${ESBUILD_COMMAND}
  COMMAND
  DEPENDS ${TYPESCRIPT_SOURCES}
  COMMENT "🏗️ Compiling and bundling TypeScript sources...")

add_custom_command(
  OUTPUT "bismuth/contents/ui"
  COMMAND
    "${CMAKE_COMMAND}" "-E" "copy_directory" "${CMAKE_CURRENT_SOURCE_DIR}/ui"
    "${CMAKE_CURRENT_BINARY_DIR}/bismuth/contents/ui"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/ui/main.qml"
          "${CMAKE_CURRENT_SOURCE_DIR}/ui/popup.qml"
  COMMENT "📑 Preparing UI and metadata files...")

configure_file("metadata.desktop" "bismuth/metadata.desktop" @ONLY)

install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bismuth"
        DESTINATION "${KDE_INSTALL_DATAROOTDIR}/kwin/scripts")

add_subdirectory(icons)

=== tests/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

add_executable(test_runner)

target_sources(test_runner PRIVATE main.cpp)

target_link_libraries(
  test_runner
  PRIVATE Qt5::Core
          Qt5::Quick
          Qt5::Qml
          Qt5::Test
          KF5::ConfigCore
          KF5::ConfigGui
          Bismuth::Core)

doctest_discover_tests(test_runner)

=== src/config/kconf_update/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

install(FILES bismuth_old_conf_ui.upd bismuth_shortcuts_category.upd
              bismuth_new_logger.upd DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR})
install(PROGRAMS bismuth_old_conf_ui.sh
        DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR})

=== src/core/kconf_update/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Mikhail Zolotukhin <mail@gikari.com>
# SPDX-License-Identifier: MIT

target_sources(bismuth_core PRIVATE legacy_shortcuts.cpp)

=== debian/changelog ===
bismuth (3.1.4-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:35:17 +1100

bismuth (3.1.4-4build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:58:09 +0000

bismuth (3.1.4-4) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Bump the libkf5config-dev build dependency to 5.100.1, as it is the first
    upstream version with kconfig_compiler that properly generates the code for
    bismuth configurations.

  [ Aurélien COUDERC ]
  * Change maintainer to the Debian KDE Extras Team instead of the main
    Qt/KDE team.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 25 Dec 2022 16:09:51 +0100

bismuth (3.1.4-3) unstable; urgency=medium

  * Team upload.
  * Bump libkf5config-dev build dependency to 5.98.0-2, so that kconfig_compiler
    does not misproduce enum values for signal masks in headers.

 -- Pino Toscano <pino@debian.org>  Sun, 30 Oct 2022 06:38:17 +0100

bismuth (3.1.4-2) unstable; urgency=medium

  * Team upload.
  * Drop unused DEBDIR, and DESTDIR variables from debian/rules.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use the kf5 dh addon for the build:
    - add the pkg-kde-tools build dependency
  * Drop "nocheck" from $DEB_BUILD_MAINT_OPTIONS in debian/rules: there are no
    tests run automatically, and in case they are not wanted they should be
    disabled explicitly (e.g. via an empty dh_auto_test override).
  * Do not explicit specify the cmake buildsystem: it is the only buildsystem
    present, and the dh autodetection properly detects it.
  * Update the build dependencies according to the upstream build system:
    - add libkf5globalaccel-dev
    - annotate esbuild as :native, as it is a build tool
    - drop ninja-build, as it is not explicitly used (and thus make is used)
    - drop unused: kirigami2-dev, qml-module-qtquick-controls2,
      qml-module-qtquick-controls, qml-module-qtquick-dialogs,
      qml-module-qtquick-extras, qml-module-qtquick-layouts,
      qml-module-qtquick-localstorage, qml-module-qtquick-particles2,
      qml-module-qtquick-pdf, qml-module-qtquick-privatewidgets,
      qml-module-qtquick-scene2d, qml-module-qtquick-scene3d,
      qml-module-qtquick-shapes, qml-module-qtquick-templates2,
      qml-module-qtquick-virtualkeyboard, qml-module-qtquick-window2,
      qml-module-qtquick-xmllistmodel, qml-module-qtquick2, and
      qtquickcontrols2-5-dev
  * Explicitly depend on most of the external QML modules used at runtime:
    qml-module-org-kde-kcm, qml-module-org-kde-kirigami2,
    qml-module-qtquick-controls, qml-module-qtquick-layouts, and
    qml-module-qtquick2.
  * Disable even building the tests when cross-compiling: during build a test
    program is run to discover the test suites; since the tests are not run
    during cross-compiling anyway, stop building them
    - pass -DBUILD_TESTING=OFF in this case

 -- Pino Toscano <pino@debian.org>  Thu, 27 Oct 2022 21:09:28 +0200

bismuth (3.1.4-1) unstable; urgency=medium

  * First debian release (Closes: #1008816)

 -- Blake Lee <blake@volian.org>  Sun, 16 Oct 2022 22:07:19 -0400

=== debian/control ===
Source: bismuth
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Blake Lee <blake@volian.org>
Build-Depends:
  debhelper-compat (= 13),
  cmake (>= 3.16~),
  pkg-kde-tools,
  extra-cmake-modules (>= 5.78.0~),
  libkf5config-dev (>= 5.100.1~),
  libkf5configwidgets-dev (>= 5.78.0~),
  libkf5coreaddons-dev (>= 5.78.0~),
  libkf5declarative-dev (>= 5.78.0~),
  libkf5globalaccel-dev (>= 5.78.0~),
  libkf5i18n-dev (>= 5.78.0~),
  libkf5kcmutils-dev (>= 5.78.0~),
  libqt5svg5-dev (>= 5.15.0~),
  esbuild:native (>= 0.14.1~),
  qtbase5-dev (>= 5.15.0~),
  qtdeclarative5-dev (>= 5.15.0~),
  libkdecorations2-dev (>= 4:5.20~),
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://github.com/Bismuth-Forge/bismuth
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kwin-bismuth.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kwin-bismuth

Package: kwin-bismuth
Architecture: any
Depends:
  ${shlibs:Depends},
  ${misc:Depends},
  plasma-workspace (>= 4:5.20~),
  qml-module-org-kde-kcm,
  qml-module-org-kde-kirigami2,
  qml-module-qtquick-controls (>= 5.15.0~),
  qml-module-qtquick-layouts (>= 5.15.0~),
  qml-module-qtquick2 (>= 5.15.0~),
Description: KDE Plasma extension for tiling windows
 KDE Plasma add-on, that tiles your windows automatically
 and lets you manage them via keyboard,
 similarly to i3, Sway or dwm.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

# disable even building the tests when cross-compiling: during build
# a test program is run to discover the test suites
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CMAKE_ARGS += -DBUILD_TESTING=OFF
endif

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DUSE_TSC=OFF -DUSE_NPM=OFF $(CMAKE_ARGS)
